#ifndef TYPES_H
#define TYPES_H

//
enum disciplineType {
  Search,           //  use the best one that can be found
  XO,          //  Using only a DAC to set the tuning voltage
  TCXO,             //  Using the DAC&thermometer to set the tuning voltage
  Ext10,            //  external 10 MHz-locked ADF4001
  GNSS,             //  GNSS timepulse locks the ADF4001
  //  None
};
//
//
struct state {                // state of the device. Used for setting and saving default operating conditions.
  char fill[500];             //  I've forgotten what this does. Reserves space?
  char ssid[32];              // WiFi stuff
  char pass[32];              // These must be  char [] for EEPROM storage which requires fixed length!!
  //
  uint32_t   fclock0;          //
  uint32_t   fclock1;
  uint32_t   fclock2;
  uint32_t   fclock3;
  uint32_t   fclock4;
  uint32_t   fclock5;
  uint32_t   fclock6;
  uint32_t   fclock7;
  
  uint8_t pwr[8];     
  disciplineType discipline;  //  discipline drives Si5351, ADF4001 settings
  boolean autoPromote;
  //
  boolean cpdisable;          // 0 means current enabled
  float cpcurrent;          // ADF4001 charge pump current  0:7
  uint8_t pllMux;             // what the ADF4001 MUX output reads

  uint16_t GNSSpfdScaling ;    // GNSS R&N Dividers
  uint16_t EXTpfdScaling ;     // Ext10 R&N Dividers
  //
  uint16_t dacsetting;          //  present DAC setting initially at a dacnominal default not adjusted for current T
  uint16_t refVCXOdac;          //  un-TCed dacsetting at refVCXOT , user or system updates it from initial DEFAULT_DACNOMINAL
  float refVCXOT ;              //  measurement T for refVCXOdac, user updates it  from  DEFAULT_TNOMINAL
  float vcxoTC;                 //  bits/degree slope of XO through tnominal setting
  //
  boolean firstrun;             //  whether is first time through after code upload
  //
  boolean rxconverter;          //  whether whether rxconverter path is enabled
  boolean preamp;               //  whether receive preamp is enabled
  volatile  boolean txconverter;//  whether transmitting is enabled
  volatile  boolean transceive; //  whether 1 or 2 cables to HF receiver

  boolean gnssReset;            //  Factory reset at first or next run
  uint32_t lo1Freq;             //  Converter Tuning
};
#endif
