#ifndef GNSSTime_h
#define GNSSTime_h
//
#include	<Arduino.h>
#include <Wire.h>                                       //  Needed for I2C defaults and access to GNSS
#include "SparkFun_u-blox_GNSS_Arduino_Library.h"       //  http://librarymanager/All#SparkFun_u-blox_GNSS
#include "AAconfig.h"
#include "ADF4001.h"
//
// https://github.com/u-blox/tracker/blob/master/docs/u-blox7-V14_ReceiverDescrProtSpec_(GNSS.G7-SW-12001)_Public.pdf
//
 struct {
  boolean GPS = true;
  boolean SBAS = false;                                 //  Turn off the default-on SBAS sybsytem per documentation (GNSS.G7-SW-12001, 12.2).
  boolean GALILEO = true;
  boolean BEIDOU = true;
  boolean GLONASS = true;
  boolean QZSS = false;
} gnssState ;
//
extern float calcArefV;                    //  best guess at actual ADC Aref
uint8_t numSats();
boolean GNSSsetup();
extern uint16_t averageBitRead(int apin);
extern SFE_UBLOX_GNSS myGNSS;
extern UBX_NAV_SAT_data_t *ubxDataStruct;
extern boolean tpCapableGNSSPresent;       //  true if have comms to uBlox
extern boolean timePulsePresent;                 //  true if uBlox is generating a timepulse for reference, otherwise false
extern struct state defaultstate, activestate ;
extern void writeStateToEEPROM(state &stateToWrite);
extern boolean satLocked;
//
boolean checkSatlocked();
boolean setTimepulsePinIsReference(boolean tp);   //  turns TP on
//
#endif
