
#ifndef RefGen_h
#define RefGen_h
//
#include <Arduino.h>

#include "ABTypes.h"
#include "AAconfig.h"

#include "si5351.h"
#include "ADF4351.h"
#include "Adafruit_MCP4725.h"
#include "ADF4001.h"
#include "MCP47x6.h"     // DAC for lock detect
#include "BigNumber.h"
#include "SparkFun_u-blox_GNSS_Arduino_Library.h"  //http://librarymanager/All#SparkFun_u-blox_GNSS

void setTCXOTuneV(float temperature); //  takes temperature and adjusts DAC setting from a calculation or table (when implemented)
void writeDAC(uint16_t setting);
void changeDiscipline(disciplineType discipline);
 
uint16_t averageBitRead(int apin);
float readPCBTemp();
void setHWDiscipline(disciplineType discipline);
void pauseit(String prompt);
 
extern Si5351 si5351c;
extern void setClock0( uint32_t fset);
void setClock2();
void setClockN( );

extern float calcArefV;                    //  best guess at actual ADC Aref, Volts
extern float PCBTemperature;
extern float prevPCBTemperature;
extern disciplineType  discipline, prevdiscipline;

extern  uint8_t numSats();
extern ADF4001 cleanupPLL   ;
extern MCP47x6base * myDAC ;                                    // WHY IS THIS EXTERN?
extern String getDisciplineName( disciplineType discipline);
extern state activestate;

extern boolean tpCapableGNSSPresent ;
extern boolean setTimepulsePinIsReference(boolean tp);
extern boolean timePulsePresent ;
extern boolean si5351Present  ;
extern boolean DACPresent ;
extern boolean refClockEnabled;

extern UBX_CFG_TP5_data_t timePulseParameters;

#endif
