#include "WebServer.h"

#include "ABTypes.h"
/*WiFi Web Server
  A simple web server that shows and allows manipulation of the value of lo1Freq

  Written for a network using WPA encryption. For
  WEP or WPA, change the WiFi.begin() call accordingly.

*/

IPAddress  ip, rip;

static char input_line [MAX_INPUT];

void printMacAddress(byte mac[]) {  //  print MAC address to console
  for (int i = 5; i >= 0; i--) {
    if (mac[i] < 16) {
      Serial.print("0");
    }
    Serial.print(mac[i], HEX);
    if (i > 0) {
      Serial.print(":");
    }
  }
  Serial.println();
}

void printWifiStatus() {  //  print WiFi details to console
  byte mac[6];
  WiFi.macAddress(mac);
  Serial.print("\nMAC address: ");
  printMacAddress(mac);

  // print the SSID of the network you're attached to:
  Serial.print("Connected to SSID:");
  Serial.print(WiFi.SSID());
  Serial.println(" ");

  // print your board's IP address:
  ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.print(ip);

  // print the received signal strength:
  long rssi = WiFi.RSSI();
  Serial.print(" with signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");

  // print where to go in a browser:
  Serial.println("To access the web page open a browser to ");
  Serial.print("  http://");
  Serial.print(ip);
  Serial.print(":");
  Serial.println(port);
}

void webPrintXOTemp() {
  //
  client.println("");
  client.print("XO temperature = ");
  client.print( readPCBTemp(), 1  );
  client.println(" C\n");
}

void sendPllMUXSelect() {       // sendPllMUXSelect Buttons
  //  *********************************************sendPllMUXSelect Buttons******************************************
  //  client.println("");

  client.println("--------------------------PLL MUX------------------------------------------------------------------------------");
  client.println("<form id='form'>");

  client.println("<input  onchange='this.form.submit();' type='radio' id = '0' name = 'pllMux' value='3ST'  ");
  ( activestate.pllMux ==  0 )  ?  client.println(" checked  >" )  : client.println(" >" );   //  check the  radio box
  client.println(" <label for='3ST'>3 State </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '1' name = 'pllMux' value='DLD'");
  ( activestate.pllMux ==  1 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='DLD'>Digital Lock Detect </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '2' name = 'pllMux' value='NDIV'");
  ( activestate.pllMux ==  2 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='NDIV'>N Divider </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '3' name = 'pllMux' value='VDD'");
  ( activestate.pllMux ==  3  )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='VDD'>VDD </label>");

  client.print("<br>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '4' name = 'pllMux' value='RDIV'");
  ( activestate.pllMux ==  4 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='RDIV'>R Divider </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '5' name = 'pllMux' value='OLD'");
  ( activestate.pllMux ==  5 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='OLD'>OD Lock Detect </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '6' name = 'pllMux' value='SER'");
  ( activestate.pllMux ==  6 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='SER'>Serial Data </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '7' name = 'pllMux' value='GND'");
  ( activestate.pllMux ==  7 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='GND'>Ground </label>");

  client.println("</form><br>");

}

void sendSelectpfdScaling() {
  //  *********************************************Charge PFD divider******************************************
  //  client.println("");

  client.println("--------------------------PFD Scaling----------------------------------------------------------------------------");
  client.println("<form id='form'>");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '16' name = 'pfdScaling' value='16'");
  ( cleanupPLL.RCounter ==  16 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='5'> 1/16 </label>");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '32' name = 'pfdScaling' value='32'");
  ( cleanupPLL.RCounter ==  32 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='6'> 1/32 </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '64' name = 'pfdScaling' value='64'");
  ( cleanupPLL.RCounter ==  64 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='7'> 1/64 </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '128' name = 'pfdScaling' value='128'");
  ( cleanupPLL.RCounter ==  128 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='8'> 1/128 </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '256' name = 'pfdScaling' value='256'");
  ( cleanupPLL.RCounter ==  256 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='256'> 1/256 </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '512' name = 'pfdScaling' value='512'");
  ( cleanupPLL.RCounter ==  512 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='512'> 1/512 </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '1024' name = 'pfdScaling' value='1024'");
  ( cleanupPLL.RCounter ==  1024 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='1024'> 1/1024 </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '2048' name = 'pfdScaling' value='2048'");
  ( cleanupPLL.RCounter ==  2048 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='4'> 1/2048 </label> ");

  //
  //
  client.print("&nbsp&nbsp&nbsp&nbsp&nbsp&nbsppfd reference = ");
  client.print(cleanupPLL.referencePinFreq / (cleanupPLL.RCounter * 1000));
  client.println(" kHz");
  client.println("</form><br>");
}

void selectCPI() {
  client.println("<br>--------------------------Charge Pump Current-----------------------------------------------------------------");
  client.println("<form id='form'>");

  client.println("<input  onchange='this.form.submit();'  type='radio' id = '0' name = 'cpdisable' value=1  ");
  ( activestate.cpdisable == 1 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for=1>Disabled</label> ");

  client.println("<input  onchange='this.form.submit();'  type='radio' id = '0' name = 'cpdisable' value=0  ");
  ( activestate.cpdisable == 0 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for=true>Enabled</label> ");
  client.println("<br>");

  client.println("</form>");


  if (!(activestate.cpdisable) == 1 ) { // if charge pump is turned on send selection form

    client.println("<form id='form'>");

    client.println("<input  onchange='this.form.submit();'  type='radio' id = '0' name = 'cpcurrent' value='0'  ");
    ( activestate.cpcurrent ==  0 )  ?  client.println(" checked  >" )  : client.println(" >" );   //  check the  radio box
    client.println(" <label for='0'> .6 mA </label> ");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '1' name = 'cpcurrent' value='1'");
    ( activestate.cpcurrent ==  1 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='1'> 1.2mA </label> ");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '2' name = 'cpcurrent' value='2'");
    ( activestate.cpcurrent ==  2 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='2'> 1.8mA </label> ");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '3' name = 'cpcurrent' value='3'");
    ( activestate.cpcurrent ==  3 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='3'> 2.5mA </label> ");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '4' name = 'cpcurrent' value='4'");
    ( activestate.cpcurrent ==  4 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='4'> 3.1mA </label> ");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '5' name = 'cpcurrent' value='5'");
    ( activestate.cpcurrent ==  5 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='5'> 3.8mA </label>");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '6' name = 'cpcurrent' value='6'");
    ( activestate.cpcurrent ==  6 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='6'> 4.4mA </label> ");

    client.println("<input onchange='this.form.submit();'  type='radio' id = '7' name = 'cpcurrent' value='7'");
    ( activestate.cpcurrent ==  7 )  ?  client.println(" checked  >" )  : client.println(" >" );
    client.println("<label for='7'> 5mA </label>");

  }

  client.println("</form><br>");
}

void selectClock1() {
  //  ********************************************* Select Clock1 Frequency******************************************

  client.println("--------------------------Select Clock1 Frequency------------------------------------------------------------");
  client.println("<form id='form'>");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '10' name = 'clock1' value='10'");
  ( activestate.fclock1 ==  freq10M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='10'> 10 MHz </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '20' name = 'clock1' value='20'");
  ( activestate.fclock1 ==  freq20M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='20'> 20 MHz </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '25' name = 'clock1' value='25'");
  ( activestate.fclock1 ==  freq25M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='25'> 25 MHz </label> ");

  client.println("<input onchange='this.form.submit();'  type='radio' id = '27' name = 'clock1' value='27'");
  ( activestate.fclock1 ==  freq27M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='27'> 27 MHz </label> ");
  //
  client.println("<input onchange='this.form.submit();'  type='radio' id = '100' name = 'clock1' value='100'");
  ( activestate.fclock1 ==  freq100M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='100'> 100 MHz </label>");
  //
  client.print("<br>");
  client.println("</form>");

}

void BandSelect() {

  //  *********************************************Band Select Buttons******************************************
  client.println("<br>");
  client.println("<form id='form'>");

  client.println("<input  onchange='this.form.submit();' type='radio' id = '2200' name = 'requestedBand' value='2200'  ");
  ( requestedBand ==  2200)  ?  client.println(" checked  >" )  : client.println(" >" );                                     //  check the  radio box
  client.println(" <label for='2200'> 2200m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '630' name = 'requestedBand' value='630'");
  ( requestedBand ==  630 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='630'> 630m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '160' name = 'requestedBand' value='160'");
  ( requestedBand ==  160 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='160'> 160m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '80' name = 'requestedBand' value='80'");
  ( requestedBand ==  80 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='80'> 80m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '60' name = 'requestedBand' value='60'");
  ( requestedBand ==  60 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='60'> 60m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '40m' name = 'requestedBand' value='40'");
  ( requestedBand ==  40 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='40'> 40m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '30' name = 'requestedBand' value='30'");
  ( requestedBand ==  30 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='30'> 30m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '20' name = 'requestedBand' value='20'");
  ( requestedBand ==  20 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='20'> 20m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '17' name = 'requestedBand' value='17'");
  ( requestedBand ==  17 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='17'> 17m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '15' name = 'requestedBand' value='15'");
  ( requestedBand ==  15 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='15'> 15m </label> ");

  client.println("<br>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '12' name = 'requestedBand' value='12'");
  ( requestedBand ==  12 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='12'> 12m </label> ");


  client.println("<input onchange='this.form.submit();' type='radio' id = '10' name = 'requestedBand' value='10'");
  ( requestedBand ==  10 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='10'> 10m </label> ");

  //======================================

  client.println("<input  onchange='this.form.submit();' type='radio' id = '6' name = 'requestedBand' value='6'  ");
  ( requestedBand ==  6 )  ?  client.println(" checked  >" )  : client.println(" >" );                                     //  check the  radio box
  client.println(" <label for='6'> 6m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '4' name = 'requestedBand' value='4'");
  ( requestedBand ==  4 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='4'> 4m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '2' name = 'requestedBand' value='2'");
  ( requestedBand ==  2 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='2'> 2m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '135' name = 'requestedBand' value='1'");
  ( requestedBand ==  1 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='1'> 1.35m </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '70' name = 'requestedBand' value='70'");
  ( requestedBand ==  70 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='70'> 70cm </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '33' name = 'requestedBand' value='33'");
  ( requestedBand ==  33 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='33'> 33cm </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '23' name = 'requestedBand' value='23'");
  ( requestedBand ==  27 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='23'> 23cm </label>");

  client.println("</form>");
  //
  //  Serial.print("  requestedBand = "); Serial.print( requestedBand  );
  //  Serial.print("  Ftune = "); Serial.println(Ftune);
}//

void sendSelectManualClock()  { //  sends forms to the home page  to set each clock frequency & power
  client.println("-------------------------------------- Manual Set ------------------------------------------------<br>"); \
  client.print("pllA is ");
  client.print(si5351c.plla_freq / 1e8, 3 );
  client.print(" MHz  &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp");
  client.print("pllB is ");
  client.print(si5351c.pllb_freq / 1e8, 3 );
  client.print(" MHz <br>");
  //
  client.print("<p>Clock frequencies are  512000 <  <b>set in Hz</b> < 225000000 <br><br>");
  //
  if (COMPILED_FOR_REFERENCE)  {
    client.print("*Clock0 owns pll A for disciplining = ");
    client.print(si5351c.clk_freq[0] / (1e8 ), 4);
    client.println(" MHz");
    client.print(pwrStr[activestate.pwr[0]]);
    client.print("<br>");
    //
    // ==CLK1-7 Freq===
    for (uint8_t i = 1; i < MAX_CLKS; i++)    {
      uint32_t CLKiFreq = si5351c.clk_freq[i] / 100; //  Hz
      uint8_t CLKiPwr = 1;
      client.print("<form method='GET' style='display:inline;' > "); // everything to end of form inline?
      switch (i) {
        case 1:
          client.print("<label form='quantity'>set Clock1   </label>");
          client.print("<input  background-color=transparent; size=7  type='number.toPrecision(0)' id='quantity' name = setCLK1Freq value=" );
          break;
        case 2:
          client.print("<label form='quantity'>set Clock2   </label>");
          client.print("<input size=7 type='number.toPrecision(0)' id='quantity' name = setCLK2Freq value=" );
          break;
        case 3:
          client.print("<label form='quantity'>set Clock3   </label>");
          client.print("<input size=7 type='number.toPrecision(0)' id='quantity' name = setCLK3Freq value=" );
          break;
        case 4:
          client.print("<label form='quantity'>set Clock4   </label>");
          client.print("<input size=7 type='number.toPrecision(0)' id='quantity' name = setCLK4Freq value=" );
          break;
        case 5:
          client.print("<label form='quantity'>set Clock5   </label>");
          client.print("<input size=7 type='number.toPrecision(0)' id='quantity' name = setCLK5Freq value=" );
          break;
        case 6:
          client.print("<label form='quantity'>set *Clock6   </label>");
          client.print("<input size=7 type='number.toPrecision(0)' id='quantity' name = setCLK6Freq value=" );
          break;
        case 7:
          client.print("<label form='quantity'>set Clock7   </label>");
          client.print("<input size=7 type='number.toPrecision(0)' id='quantity' name = setCLK7Freq value=" );
          break;
        default:      client.print("<input type='number.toPrecision(0)' id='quantity' name = noname value=" );
          break;
      }
      if   (si5351c.clk_freq[i] == 0)  client.print("OFF ") ;  //  Fill the box
      else client.print(CLKiFreq );
      client.print(" min='4000' max='150000000'>");    //  end of freq input description
      client.print(" = ");
      client.print(si5351c.clk_freq[i] / (1e8 ), 6);
      client.print(" MHz ");
      //
      client.println("</form>");

      if ((i == 6) | (i == 7)) {
        (si5351c.pll_assignment[i] == 0) ? client.print("  on pllA ") :  client.print("  pllB/Int ");
      }
      else  {
        (si5351c.pll_assignment[i] == 0) ? client.print("  on pllA ") :  client.print("  on pllB  ");
      }
      client.print(pwrStr[activestate.pwr[i]]);      //            send form to display and select power

      client.print(" <form method='GET' style='display:inline;' >");
      String clkpwr = "pwr" + String(i);  //  e,g,"pwr4"
      client.print("<select onchange='this.form.submit()'   name = "); client.print(clkpwr); client.print(">");
      client.print("<option>set power</option>"); //  1st option is the label for the selector box, I think
      client.print("<option>4</option>");
      client.print("<option>9</option>");
      client.print("<option>11</option>");
      client.print("<option>13</option>");
      client.print("</select>");
      client.print("</form>");


      client.print("</form><br><br>");
    } //  end of stepping through clocks
  } // endcompiled for REference
}

void sendSelectUserClock()  {
  client.println("----------------------------------- Clock2 Presets ----------------------------------------------");

  client.println("<form id = 'form'>");

  client.println("<input   onchange='this.form.submit();' type='radio' id = '10' name = 'presetClock' value='10'  ");
  ( activestate.fclock2 ==  freq10M )  ?  client.println(" checked  >" )  : client.println(" >" );                                     //  check the  radio box
  client.println(" <label for='10'> 10 MHz </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '20' name = 'presetClock' value='20'");
  ( activestate.fclock2 ==  freq20M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='20'> 20 MHz </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '25' name = 'presetClock' value='25'");
  ( activestate.fclock2 ==  freq25M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='25'> 25 MHz </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '27' name = 'presetClock' value='27'");
  ( activestate.fclock2 ==  freq27M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='27'> 27 MHz </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '50' name = 'presetClock' value='50'");
  ( activestate.fclock2 ==  freq50M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='40'> 50 MHz </label> ");
  client.print("<br>");

  client.println("<input onchange='this.form.submit();' type='radio' id = '80' name = 'presetClock' value='80'");
  ( activestate.fclock2 ==  freq80M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='80'> 80 MHz </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = '100' name = 'presetClock' value='100'");
  ( activestate.fclock2 ==  freq100M )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='100'> 100 MHz </label>");

  client.println("</form>");

  //  client.print("SDRs ");
  client.print("<form method='GET' style='display:inline;' > ");
  client.print("<select onchange='this.form.submit()'   name = 'presetClock'>");   // variable is 'name', value = the selection
  client.print("<option>SDRs</option>");
  client.print("<option>Kiwi</option>");
  client.print("<option>RTL</option>");
  client.print("<option>TRXck6</option>");
  client.print("</select>");
  client.println("</form>");

  //  client.print("\tIcom Models ");
  client.print("<form method='GET' style='display:inline;' > ");
  client.print("<select onchange='this.form.submit()'   name = 'presetClock'>");   // variable is 'name', value = the selection
  client.print("<option>Icom</option>");   // top title in selection box
  client.print("<option>IC706</option>");
  client.print("<option>IC7300</option>");
  client.print("</select>");
  client.print("</form>");

  //  client.print("\tKenwood Models ");
  client.print("<form method='GET' style='display:inline;' > ");
  client.print("<select onchange='this.form.submit()'   name = 'presetClock'>");   // variable is 'name', value = the selection
  client.print("<option>Kenwood</option>");
  client.print("<option>TS200</option>");
  client.print("<option>Others</option>");
  client.print("</select>");
  client.print("</form>");

  //  client.print("\tYaesu Models ");
  client.print("<form method='GET' style='display:inline;' > ");
  client.print("<select onchange='this.form.submit()'   name = 'presetClock'>");   // variable is 'name', value = the selection
  client.print("<option>Yaesu</option>");
  client.print("<option>FT8x7</option>");
  client.print("<option>Others</option>");
  client.print("</select>");
  client.print("</form> <br>");


  client.print("<br");
  client.print("</style >");

  sendSelectManualClock();

} //  end sendSelectUserClock()

void sendSelectDiscipline() {
  //  client.println("");
  //  client.println("<br>=======================Discipline=======================================");
  client.println("-----------------------Discipline---------------------------------------");
  /*

  */
  client.println("<form id='form'>");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'GNSS' name = 'discipline' value='4'  ");
  ( activestate.discipline ==  GNSS )  ?  client.println(" checked  >" )  : client.println(" >" );   //  check the  radio box
  client.println(" <label for='GNSS'> GNSSDO </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Ext10' name = 'discipline' value='3'");
  ( activestate.discipline ==  Ext10 )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Ext10'> Ext10 </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'TCXO' name = 'discipline' value='2'");
  ( activestate.discipline ==  TCXO )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='TCXO'> TCXO </label> ");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'XO Only' name = 'discipline' value='1'");
  ( activestate.discipline ==  XO )  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='No Discipline'> XO Only </label> ");

  client.println("</form>");
  //
  client.println("<form id='form'>");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'autoPromote' value='1'  ");
  ( activestate.autoPromote == true)  ?  client.println(" checked  >" )  : client.println(" >" ); //  check the  radio box
  client.println(" <label for='Enabled'> Promote to Locked</label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'autoPromote' value='0'");
  ( activestate.autoPromote == false)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Leave discipline as selected</label>");

  client.println("</form>");
}//

void sendcurlInfo() {
  //*********************************************************************************************************************

  client.print("<br>");
  client.print("<br> curl --get --data 'presetClock=100' http://" );
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.println("\t will set CK2 frequency to 100 MHz" );

  client.print("<br>curl --get --data 'Status=2' http://" );
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("\t returns status information as text." );
}

void sendDacXOset()  {
  client.println("-------------------------------------------DAC/Temp Setting for XO--------------------------------------------------------");
  //  client.println("");
  client.print("<form method='GET'>");
  client.print("<label form='quantity'>   0 < refVCXOdac < 4095  </label>");
  client.print("<input type='number' id='quantity' name = 'refVCXOdac' value=");
  client.print(String( activestate.refVCXOdac)   );
  client.print(" min='0' max='4095' >");
  client.print("</form>");
}

void sendTCTableClear()  {
  client.println("");
  client.print("<a href=http://" );       //  URL to Refresh Page
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("");
  client.print("/?TCTableClear=1");

  client.println("> Clear TC table</a> (also writes active state to NVRAM) <br>");  //  label
}
 
void sendSetSynths() { //  for spur testing
  // ****************************************Synth Enable Buttons************** // key is 'name', 'value' = the selection

  //  Note that disabling an 'A' also disables the corresponding 'B' output
  //
  client.println("<br>");
  client.print("<form method='GET'>");
  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>rx&tx LO1 CHIP Power synth1: ");                                                      // rx and tx LO1's  POWER

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'SetSynth1' value='1'  ");
  ( Synth1.synthIsPowered == true)  ?  client.println(" checked  >" )  : client.println(" >" ); //  check the  radio box
  client.println(" <label for='Enabled'> On</label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'SetSynth1' value='0'");
  ( Synth1.synthIsPowered == false)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Off</label>");
  client.println("</form>");
  //
  client.print("<form method='GET'>");
  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>tx LO1 AUX Output: ");                                                 //  txLO1

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'SetSynth1B' value='1'  ");
  ( Synth1.auxIsPowered == true)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Enabled'>On </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'SetSynth1B' value='0'");   //  txLO1
  ( Synth1.auxIsPowered == false)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Off</label>");
  client.println("</form>");
  //
  client.println("<br>");
  //
  client.print("<form method='GET'>");
  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>rx&tx LO2&LO3s CHIP Power synth2: ");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'SetSynth2' value='1'  ");
  ( Synth2.synthIsPowered == true)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Enabled'> On</label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'SetSynth2' value='0'");
  ( Synth2.synthIsPowered == false)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Off</label>");
  client.println("</form>");//
  //
  //
  client.print("<form method='GET'>");
  client.println("<form id='form'>");
  client.println("  <p id=form-prompt> rx&tx LO2&LO3 MAIN Output: ");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'SetLO3' value='1'  ");   // rx and tx LO3's & LO2's
  ( Synth2.mainIsPowered == true)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Enabled'> On </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'SetLO3' value='0'");
  ( Synth2.mainIsPowered == false)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Off</label>");
  client.println("</form>");
  //

  client.print("<form method='GET'>");
  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>rx&tx LO2s AUX Output: ");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'SetSynth2B' value='1'  ");   // rx and tx LO2's
  ( Synth2.auxIsPowered == true)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Enabled'> On</label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'SetSynth2B' value='0'");
  ( Synth2.auxIsPowered == false)  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Off </label>");
  client.println("</form>");

}
 
void sendTXenable() {
  // ****************************************Extension Enable Buttons************** // key is 'name', 'value' = the selection
  //  client.println("");

  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>UpConverter: ");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'tx_en' value='1'  ");
  activestate.txconverter  ?  client.println(" checked  >" )  : client.println(" >" ); //  check the  radio box
  client.println(" <label for='Enabled'> Enable</label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'tx_en' value='0'");
  !activestate.txconverter  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Disable</label>");

  client.println("</form>");
}
 
void sendForceTx() {
  // ****************************************Extension Enable Buttons************** // key is 'name', 'value' = the selection
  //  client.println("");

  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>Force Transmit: ");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'ForcePTT' value='1'  ");
  forceTx  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Enabled'> Enable</label>");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'ForcePTT' value='0'");
  !forceTx  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Disabled'> Disable</label>");

  client.println("</form>");
}
 
void sendRXenable() {
  // ****************************************Extension Enable Buttons************** // key is 'name', 'value' = the selection
  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>RX Path: ");

  client.println("<input onchange='this.form.submit();' type='radio' id = 'Enabled' name = 'rx_en' value='1'");
  activestate.rxconverter  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println("<label for='Enabled'> Converter</label>");

  client.println("<input  onchange='this.form.submit();' type='radio' id = 'Disabled' name = 'rx_en' value='0'  ");
  !activestate.rxconverter  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Disabled'> HF Antenna</label>");

  client.println("</form>");
}
 
void sendSetPreamp() {
  // *******************************************Preamp Radio Buttons**************************************************
  //  client.println("");
  //  (activestate.preamp == true) ? client.println("Select Preamp\n") : client.println("Preamp is  Bypassed\n")  ;

  client.print("<form method='GET'>");

  client.println("<form id='form'>");
  client.println("  <p id=form-prompt>\t Preamp: ");

  client.println("<input onchange='this.form.submit();' type='radio' id='Enabled' name = 'setPreamp' value='1'  ");
  activestate.preamp  ?  client.println(" checked  >" )  : client.println(" >" );      //  check the  radio box
  client.println(" <label for='Enabled'>Enable </label>");

  client.println("<input onchange='this.form.submit();' type='radio' id='Disabled' name = 'setPreamp' value='0'  ");
  !activestate.preamp  ?  client.println(" checked  >" )  : client.println(" >" );
  client.println(" <label for='Disabled'>Disable </label>");

  client.print("</select>");

  client.println("</form>");
}
 
void setSynth1_Ftune() {
  client.println("-------------------------Manual Frequency Setting--------------------------------------------------------------------");
  client.println("<br>");
  //  client.println(" LO1 VCO = Ftune + 2185  to put Ftune centered at 20 MHz output from converter. ");

  client.print("<form method='GET'>");
  client.println("<form id='form'>");

  client.print("set LO1 VCO 2185 MHz above Ftune to tune 0 to 2000 MHz (can go down to 38 MHz for testing)");
  client.println("<br>");
  client.print("<label form='quantity' >  2185 < LO1 < 4185 </label>");
  client.print("<input type='number' id='quantity' name = 'lo1Freq' value=");
  client.print( String(activestate.lo1Freq / freq1M) );
  client.print(" min='38' max='4185'>");
  client.println("</form>");


  client.print("\t or ");
  client.print("<form method='GET'>");
  client.println("<form id='form'>");
  client.print("<label form='quantity'>   0 < Ftune < 2000  </label>");
  client.print("<input type='number' id='quantity' name = 'Ftune' value=");
  client.print( String((int32_t)Ftune) );
  client.print(" min='0' max='2000'>");
  client.print(" for 20 MHz IF3 output set Kiwi:admin:scale_0ffset to ");
  client.print(  String(int32_t(Ftune - 20 ) ) );
  client.println (" MHz");
  client.println("</form>");

  requestedBand = 99; //  manual entry overrides band preset
}
 
void SendLockStatus() {  //  Display lock status for either Ext10 or GNSS
  if ( (activestate.discipline == Ext10) ) {
    if ( cleanupPLL.checkADF4001locked() )
      client.print (" <h3 style='color:green;'>Reference PLL is Locked to Ext10</h3> " );
    else
      client.print (" <h3 style='color:red;'>Reference PLL is Unlocked </h3> " );
  }
  else if ( (activestate.discipline == GNSS) ) {
    if ( cleanupPLL.checkADF4001locked() )
      client.print (" <h3 style='color:green;'>Reference is Locked to GNSS</h3> " );
    else
      client.print (" <h3 style='color:red;'>Reference is  Unlocked </h3> " );
  }
  client.println("");
}
 
void sendRefresh() {
  //  client.println("----------------------------------------------------------------------------------------------------------------------------");
  client.print("<a href=http://" );   //  URL to Refresh Page
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("");
  client.print("/?Status=");
  client.print(htmlPageToSend);
 
  client.println("> Refresh this page</a><br>");  //  label<h3 style='color:black;font-size:16px;'> Back to Home Page</h3>
}
 
void sendSelectStatusPage() {
  client.print("<a href=http://" );   //  URL to Status Page
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("/?Status=1");
  client.print(">Status & Utility Page</a>");
  client.println("\n");
}
 
void sendSatBars(UBX_NAV_SAT_data_t *ubxDataStruct) {
  byte minGoodCN = 40;                              //  minimum C/N for high quality timepulse
  uint8_t cno;                                      //  reported C/N
  byte  goodSatCount = 0;                           //  number of quality sats
  byte  nonzSatCount = 0;                           //  number of sats with non-zero SNR

  client.print(ubxDataStruct->header.numSvs);       // Print the SV #
  client.println(" Satellites (including C/N=0)<br>");
  for (uint16_t block = 0; block < ubxDataStruct->header.numSvs; block++) // For each SV
  {
    cno = ubxDataStruct->blocks[block].cno;
    if (ubxDataStruct->blocks[block].cno > 0)  {    //   these are sometimes 0 and aren't useful so don't print
      switch (ubxDataStruct->blocks[block].gnssId)                          // Print the GNSS ID
      {
        case 0:
          client.print(F("US GPS&nbsp&nbsp&nbsp&nbsp&nbsp "));
          break;
        case 1:
          client.print(F("SBAS "));
          break;
        case 2:
          client.print(F("GALILEO&nbsp "));
          break;
        case 3:
          client.print(F("BeiDou "));
          break;
        case 4:
          client.print(F("IMES "));
          break;
        case 5:
          client.print(F("QZSS "));
          break;
        case 6:
          client.print(F("GLONASS "));
          break;
        default:
          client.print(F("UNKNOWN "));
          break;
      }

      if (ubxDataStruct->blocks[block].svId < 10) client.print(F("&nbsp&nbsp&nbsp"));
      else if (ubxDataStruct->blocks[block].svId < 100) client.print(F("&nbsp"));
      client.print(F("&nbsp"));
      client.print(ubxDataStruct->blocks[block].svId); // Print the SV ID

      client.print(F("&nbsp"));
      if (cno > 0) nonzSatCount++;
      if (cno > minGoodCN) goodSatCount++;
      // Print the signal strength as a bar chart

      for ( cno = 0; cno < ubxDataStruct->blocks[block].cno; cno++)
        (cno == minGoodCN) ? client.print(F("|")) : client.print(F("="));
      client.print("&nbsp");
      client.print(cno);
      client.println("<br>");
    }
  }
  client.print(" C/N >0 count = ");   client.print(nonzSatCount);
  client.print("&nbsp&nbsp C/N >40 count = ");   client.println(goodSatCount);
  client.println("<br>");
}
 
void sendSelectSleep()  {
  client.print("<a href=http://" );
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("/?Sleep=1");
  client.println(">Sleep 16 seconds</a> <br>");
}
 
void sendResetGNSSmodule()  { //  sets up to perform a reset to factory defaults of the GNSS module
  client.println("");
  client.print("<a href=http://" );
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("/?GNSSreset=1");
  client.println(">Factory Reset GNSS module on next cold start</a>");
  client.println("<br>&nbsp&nbsp[Note:This is a Utility Function that rarely needs to be used]");
  client.println("<br>\tRestart, Wait 30 seconds, Then remove & reapply power to restart again.");
}
 
void SendHomePage( WiFiClient client ) {
  // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
  // and a content-type so the client knows what's coming, then a blank line:
  client.println("HTTP/1.1 200 OK");
  client.println("Content-type:text/html");
  client.println("Connection: close");  // the connection will be closed after completion of the response
  client.println();                     //    Need this as a terminator

  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
  // the content of the HTTP response follows the header:

  if (!COMPILED_FOR_REFERENCE) {    //  FE or Transverter title,backgrounds & color, FE&preamp enable & FE tuning
    if (!TRANSVERTER) {             //  RX Converter Background
      client.print("<title>FE"); // tab title
      client.print(".");
      client.print(ip[3]);
      client.print("</title>");     //  subnet address shown in tab so I can tell RE,FE, TR apart. Too many things!
      client.print("<body style='background-color:#ccddcc;'>");
      client.print("<h1  style='color:black;font-size:40px;'>N6GN Kiwi Frequency Extender</h1>");
      //
      client.println("<style>");
      client.println("  body {   ");
      client.println("background-image:");
      client.println("url(' http://www.sonic.net/~n6gn/FEBlock.png ' );   ");
      client.println("background-repeat: no-repeat;");
      client.println("background-attachment: fixed;");
      client.println("background-position: right;");
      client.println("}");
      client.println("</style>");
    }
    else {                          //  transverter Converter Background
      client.print("<title>TR"); // tab title
      client.print(".");
      client.print(ip[3]);
      client.print("</title>");     //  subnet address shown in tab so I can tell RE,FE, TR apart. Too many things!

      client.print("<body style='background-color:#ddcccc;'>");

      client.print("<h1  style='color:black;font-size:40px;'>N6GN Transverter</h1>");
      //
      //      client.println("<style>");
      //      client.println("  body {   ");
      //      client.println("background-image:");
      //      client.println("url(' http://www.sonic.net/~n6gn/TransverterBlock.png ' );   ");
      //      client.println("background-repeat: no-repeat;");
      //      client.println("background-attachment: fixed;");
      //      client.println("background-position: right;");
      //      client.println("}");
      //      client.println("</style>");
    }
    //
    sendRXenable();
    sendSetPreamp();
    if (TRANSVERTER)  {
      sendTXenable();
    }
    //    sendSetSynths();          //  for spur testing
    //
    client.println("=========================Converter Tuning============================");
    BandSelect();
    //
    setSynth1_Ftune();
  } //  end additional FE/TR controls
  //
  else {                            //  Reference title,background & color
    (MAX_CLKS == 8) ? client.print("<title>RE2") : client.print("<title>RE");    // tab title for Reference PCBs

    client.print(".");
    client.print(ip[3]);
    client.print("</title>");     //  subnet address shown in tab so I can tell RE,FE, TR apart. Too many things!
    client.print("<body style='background-color:#efebb8;'>");
    (MAX_CLKS == 8) ? 
    client.print("<h1 style='color:black;font-size:40px;'>RE2</h1>") : client.print("<h1 style='color:black;font-size:40px;'>RE</h1>");
  }
  //  Common functions follow
  sendSelectUserClock();
  //
  sendSelectDiscipline();
  //
  SendLockStatus();
//  client.print("<br>");
  //
  sendRefresh();
  //
  client.print("<br>");
  sendSelectStatusPage();
  //
  //
  client.println("</body>");
  client.println("</html>");
  client.print("\n");           // The HTTP response ends with another blank line:
} // end SendHomePage
 
void SendBlankPage( WiFiClient client )  {
  // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
  // and a content-type so the client knows what's coming, then a blank line:
  client.println("HTTP/1.1 200 OK");
  client.println("Content-type:text/html");
  client.println("Connection: close");  // the connection will be closed after completion of the response
  client.println(); //  This is a necessary terminator (I think)
  //
  //
  client.println("This page left intentionally blank");
  // The HTTP response ends with another blank line:
  client.print("\n");
} //  end SendBlankPage
 
void SendStatusTextPage( WiFiClient client )  {
  // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
  // and a content-type so the client knows what's coming, then a blank line:
  client.println("HTTP/1.1 200 OK");
  client.println("Content-type:text/html");
  client.println("Connection: close");  // the connection will be closed after completion of the response
  client.println(); //  This is a necessary terminator (I think)
  //
  //
  client.print("\nCompiled on ") ;
  client.print (F(__DATE__ " " __TIME__));
  client.println(SWVERSION) ;
  //
  //update presence and function flags
  (wiFiModulePresent) ? client.println("wiFiModulePresent") : client.println(" Not Present");
  if (tpCapableGNSSPresent) client.println("tpCapableGNSSPresent"); else client.println("\tuBlox Not Present");                 // updated by GNSSTime

  if (adf4001Present ) client.println("adf4001 Present"); else client.println("adf4001 Not Present");   // updated by adf4001

  if (si5351Present) client.println("si5351Present"); else client.println("si5131 Not Present");              // updated by RefGen

  if (DACPresent ) client.println("DACPresent"); else client.println("DAC Not Present");         // pot if we need the TCXO


  //  client.println("Function Inventory:");

  if (satLocked) client.println("Satellite-locked "); else client.println(" No Satellite Lock Yet");
  if (adf4001Locked) client.println("adf4001 is Locked"); else client.println("adf4001 Not Locked");
  if (timePulsePresent) client.println("tp pin is square wave"); else client.println("tp pin is lock detect");

  if (COMPILED_FOR_REFERENCE)  {
    client.print("Clock1 = ");
    client.print(String(activestate.fclock1 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[1]]);

    client.print("Clock2 = ");
    client.print(String(activestate.fclock2 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[2]]);

    client.print("Clock3 = ");
    client.print(String(activestate.fclock3 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[3]]);
    
    client.print("Clock4 = ");
    client.print(String(activestate.fclock4 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[4]]);
    
    client.print("Clock5 = ");
    client.print(String(activestate.fclock5 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[5]]);
    
    client.print("Clock6 = ");
    client.print(String(activestate.fclock6 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[6]]);
    
    client.print("Clock7 = ");
    client.print(String(activestate.fclock7 / 1e6, 6));
    client.print(" MHz "); 
    client.println(pwrStr[activestate.pwr[7]]);
  }
  // *******************************************PLL settings**************************************************

  client.print("PFDmax  = ");
  client.print(  (float) cleanupPLL.referencePinFreq  / (   1e3), 3 );
  client.println(" kHz");

  client.print("PFD Scaling  = ");
  client.println(  cleanupPLL.RCounter  );

  client.print("PFD = ");
  client.print(  (float) cleanupPLL.referencePinFreq  / (1000 * cleanupPLL.RCounter), 3 );
  client.println(" kHz");

  client.print("CP Current setting = ");
  uint8_t result = cleanupPLL.ADF4001_R[2].getbf( 15, 3);
  client.print(.625 * result + .625);
  client.println(" mA");

  client.print("Charge Pump is ");
  activestate.cpdisable ? client.println("disabled") :   client.println("enabled");


  client.print("disciplining is ");
  client.println (getDisciplineName(activestate.discipline) );

  if (discipline == GNSS || discipline == Ext10 ) {
    if (cleanupPLL.checkADF4001locked())
      client.println("Reference is Locked" );
    else
      client.println("Reference is  Unlocked" );
  }




  if (!COMPILED_FOR_REFERENCE) {  //  send ADF4351 lock status


    if (Synth1.ADF4351locked())
      client.println(" <h3 style='color:green;'>LO1 PLL is Locked </h3> " );
    else
      client.println(" <h3 style='color:red;'>LO1 PLL is Unlocked </h3> " );
    //    client.println("<br>");

    if (Synth2.ADF4351locked())
      client.println(" <h3 style='color:green;'>LO2&LO3 PLL is Locked </h3> " );
    else
      client.println(" <h3 style='color:red;'>LO2&LO3 PLL is Unlocked </h3> " );
    //    client.println("<br>");
  }

  client.print("TCXO temperature = ");
  client.print( readPCBTemp(), 1  );
  client.println("C");


  client.print("TCXO dac setting = ");
  client.println( activestate.dacsetting );

  client.print("Vset measures ");
  uint16_t db = averageBitRead(VSET_PIN); 
  client.print (  (  (float) db / 4096.0) * calcArefV , 3 ); //  ADC uses reference V on at IoT pin
  client.println(" VDC");
 
  long rssi = WiFi.RSSI();
  client.print("WiFi is reporting ");
  client.print(  rssi  );
  client.print(" dBm from SSID: ");
  client.println(WiFi.SSID());


  //  client.println("");
  if (!COMPILED_FOR_REFERENCE)  {
    client.println("RX Antenna  = ");
    if (activestate.rxconverter)  client.println("HF Antenna");
    else client.println("Converter");
    client.println("RX Preamp = ");
    activestate.preamp ?  client.println("Enabled") : client.println("Off");
  }


  if (TRANSVERTER)  {
    client.print("TX Converter = ");
    if (activestate.txconverter)  client.println("Enabled");
    else client.println("Disabled");
    client.print("Transceive = ");
    if (activestate.transceive)  client.println("Enabled");
    else client.println("Disabled");
  }



  if (!COMPILED_FOR_REFERENCE) {  //  send ADF4351 and LO description
    client.println("    LO1 VCO Frequency = ");
    client.println(String(Synth1.ADF4351cfreq / 1e6, 6));
    client.println(" MHz");
    client.println("<br>");

    client.println("    Synth1A+ Pwrlevel = ");
    client.println(String(Synth1.ADF4351MainPwrlevel));
    client.println("<br>");

    ( Synth1.auxIsPowered) ? client.println("    Synth1B+ is ON") : client.println("    Synth1B+ is OFF");
    client.println("\n");
    client.println("<br>");

    client.println("    Synth1B+ Pwrlevel = ");
    client.println(String(Synth1.SynthBPwrlevel));
    client.println("\n");
    client.println("<br>");

    client.println("    LO1 reference doubler = ");
    client.println(String(Synth1.ADF4351Refdoubler));
    client.println("\n");
    client.println("<br>");

    client.println("    LO1 Reference divideBy2 = ");
    client.println(String(Synth1.ADF4351Refdivider));
    client.println("<br>");

    client.println("    LO1 ClkDiv (timeout counter)= ");
    client.println(String(Synth1.ADF4351TimeoutCounter));
    client.println("<br>");

    client.println("    LO1 BandSelClock (internal VCO bands) = ");
    client.println(String(Synth1.ADF4351BandSelClock));
    client.println("<br>");

    client.println("    LO1 10 bit R Divbider = ");
    client.println(String(Synth1.ADF4351RCounter));
    client.println("<br>");

    client.println("    LO1 ChanStep = ");
    client.println(String(Synth1.ADF4351ChanStep / 1e6, 6));
    client.println("<br>");

    client.println("    LO1 Output divider = ");
    client.println(String(Synth1.ADF4351outdiv));
    client.println("<br>");

    client.println("Synth Phase comparison Frequency,         fPFD = REFin * [ (1 + D)/(R * (1 + T)) ] = ");
    client.println(String(Synth1.ADF4351PFDFreq / 1e6, 6));
    client.println(" MHz");
    client.println("where:");
    client.println("REFin is the reference frequency input = ");
    client.println(String(UWVREFERENCE / 1e6, 0));
    client.println(" MHz");
    client.println("<br>");

    client.println("D is the RF REF IN doubler bit (0 or 1) = ");
    client.println(String(Synth1.ADF4351Refdoubler));
    client.println("<br>");

    client.println("R is the RF reference division factor (1 to 1023) = ");
    client.println(String(Synth1.ADF4351RCounter));
    client.println("<br>");

    client.println("T is the reference divide-by-2 bit (0 or 1) = ");
    client.println(String(Synth1.ADF4351Refdivider));
    client.println("<br>");

    client.println("RFout is the LO1 VCO Frequency, LO1 = fpfd * (INT + (FRAC/MOD)) = ");
    client.println(String(Synth1.ADF4351cfreq / 1e6, 6));
    client.println(" where:");
    client.println("<br>");

    client.println("INT = ");
    client.println(String(Synth1.ADF4351N_Int));
    client.println("<br>");

    client.println("FRAC is the numerator of the fractional division (0 to MOD-1) = ");
    client.println(String(Synth1.ADF4351Frac));
    client.println("<br>");

    client.println("MOD is the preset fractional modulus (2 to 4095) = ");
    client.println(String(Synth1.ADF4351Mod));
    client.println("<br>");

    client.println("so, ");
    client.println("<br>");
    client.println("Frac-N  = ");
    client.println(String(Synth1.ADF4351cfreq / Synth1.ADF4351PFDFreq, 4));
    client.println("<br>");

    if (Synth1.ADF4351Frac == 0) {
      client.println("  so the synthesizer is in INTEGER mode.");
      client.println("<br>");
    }
    float Synth1core = Synth1.ADF4351cfreq  / 1e6;
    float Synth2core = Synth2.ADF4351cfreq * Synth2.ADF4351outdiv / 1e6;
    float Synth2div = Synth2.ADF4351cfreq / 1e6;
    float IF3 = 20;
    Ftune = (Synth1core - Synth2core + Synth2div + IF3 );           //  maintained in units of MHz system wide
    float IF1 = Synth1core - Ftune;                                 //  in Hz to set IF1
    float IF2 = Synth2core - IF1;
    //
    client.println("A ");
    client.println(Ftune);
    client.println(" MHz signal at the converter input with:");
    client.println("<br>");

    client.println("Synth1A+ (VCO) = ");
    client.println(String(Synth1core, 0) );
    client.println(" MHz &nbsp;  &nbsp; &nbsp; &nbsp; &nbsp&nbsp;  &nbsp; &nbsp; &nbsp; &nbsp      ===>       an IF1 = ");
    client.println(String(IF1, 0) );
    client.println(" MHz");
    client.println("<br>");

    client.println("which with Synth2B (VCO) = ");
    client.println(String(Synth2core, 0) );
    client.println(" MHz &nbsp;  &nbsp; &nbsp; &nbsp; &nbsp&nbsp;  &nbsp; &nbsp; &nbsp; &nbsp      ===>       an IF2 = ");
    client.println(String(IF2, 0) );
    client.println(" MHz");
    client.println("<br>");

    client.println("which with a LO3 ( Synth2A = Synth2B/16 ) = ");
    client.println(String(Synth2div, 0) );
    client.println(" MHz &nbsp;  &nbsp; &nbsp; &nbsp; &nbsp&nbsp;  &nbsp; &nbsp; &nbsp; &nbsp      ===>       an output at IF3 = ");
    client.println(String(IF3, 0) );
    client.println(" MHz");
    client.println("<br>");

  } // end of ADF4351 and LO description
  //
  // The HTTP response ends with another blank line:
  client.println("\n");
} //  end SendStatusTextPage
 
void SendStatusPage( WiFiClient client )  {
  // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
  // and a content-type so the client knows what's coming, then a blank line:
  client.println("HTTP/1.1 200 OK");
  client.println("Content-type:text/html");
  client.println("Connection: close");  // the connection will be closed after completion of the response
  client.println(); //  This is a necessary terminator (I think)
  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
  //  Title,background & color
  if (COMPILED_FOR_REFERENCE)  {
  ( MAX_CLKS == 8) ? client.print("<title>RE2 Status") : client.print("<title>RE Status");    // tab titles for Status Pages
  }
  else {
    if (TRANSVERTER)  client.print("<title>TR Status");
    else  client.print("<title>FE Status");
  }
  client.print(".");
  client.print(ip[3]);          //  append subnet address
  client.print("</title>");     //  subnet address shown in tab so I can tell RE,FE, TR apart. Too many things!
  //
  //
  client.print("<h2 style='color:black;font-size:30px;'>Status & Utility</h2>");
  //
  //    Background Images
  client.println("<head>");
  client.println("<style>");
  if (COMPILED_FOR_REFERENCE)  {  //  Background images
    client.println("  body {   ");
    client.println("background-image:");
    client.println("url(' http://www.sonic.net/~n6gn/GNSSReferenceBlock.png ' );   ");
    client.println("background-repeat: no-repeat;");
    client.println("background-attachment: fixed;");
    client.println("background-position: right;");
    client.println("}");
  }
  else {
    if (TRANSVERTER) {
      client.println("  body {   ");
      client.println("background-image:");
      client.println("url(' http://www.sonic.net/~n6gn/TransverterBlock.png ' );   ");

      client.println("background-repeat: no-repeat;");
      client.println("background-attachment: fixed;");
      client.println("background-position: right;");

      client.print("<h2 style='color:black;font-size:30px;'>Transverter Status</h2>");
      client.println("\n");
      client.println("}");  // end body
    }
    else {  //  RX Converter
      client.println("  body {   ");
      client.println("background-image:");
      client.println("url(' http://www.sonic.net/~n6gn/FEBlock.png ' );   ");

      client.println("background-repeat: no-repeat;");
      client.println("background-attachment: fixed;");
      client.println("background-position: right;");

      client.print("<h2 style='color:black;font-size:30px;'>RX Converter Status</h2>");
      client.println("\n");
      client.println("}");  // end body
    }
  }
  client.println("</style>");
  client.println("</head>");
  //  end  Background Images
  //
  sendRefresh();

  client.print(" <a href=http://" );
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("/?Status=");
  client.print(0);
  client.print("> <h3 style='color:black;font-size:16px;'> Back to Home Page</h3>  </a>");
  //
  client.print("Compiled on ") ;
  client.print (F(__DATE__ " " __TIME__));
  client.print(" version ") ;
  client.print(SWVERSION) ;
  client.println("<br>");

  client.println("<br>");
  //update presence and function flags
  if (wiFiModulePresent) client.println("\t&nbsp;wiFiModulePresent<br>"); else client.println("\t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;wiFi Not Present<br>");                   // updated by RefWiFiWebServer
  if (tpCapableGNSSPresent) client.println("\t&nbsp;tpCapableGNSSPresent<br>"); else client.println("\t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;uBlox Not Present<br>");                 // updated by GNSSTime
  if (adf4001Present ) client.println("\t&nbsp;adf4001 Present<br>"); else client.println("\t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;adf4001 Not Present<br>");   // updated by adf4001
  if (si5351Present) client.println("\t&nbsp;si5351Present<br>"); else client.println("\t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;si5131 Not Present<br>");              // updated by RefGen
  if (DACPresent ) client.println("\t&nbsp;DACPresent<br>"); else client.println("\t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;DAC Not Present<br>");         // pot if we need the TCXO

  if (timePulsePresent) client.print("have Satellite-locked timepulse");
  else client.println("tp is in lock detect mode<br>");
  client.println("<br>");
  //
  webPrintClkStats();
  client.println("<br>");

  // *******************************************PLL settings**************************************************

  client.println("cleanupPLL:<br>");
  client.print("&nbsp; &nbsp; PFDmax  = ");
  client.print(  (float) cleanupPLL.referencePinFreq  / (   1e6), 4 );
  client.println(" MHz<br>");

  client.print("&nbsp; &nbsp; PFD Scaling   = ");
  client.println(  cleanupPLL.RCounter   );
  client.println("<br>");

  client.print("&nbsp; &nbsp; PFD   = ");
  client.println(  (float) cleanupPLL.referencePinFreq  / (cleanupPLL.RCounter * 1000), 3 );
  client.println(" kHz<br>");

  client.print("&nbsp; &nbsp; CP Current setting = ");
  uint32_t result = cleanupPLL.ADF4001_R[2].getbf( 15, 3);
  client.println(.625 * result + .625);
  client.println(" mA<br>");

  client.println("");
  client.print("&nbsp; &nbsp; Charge Pump is ");
  cleanupPLL.cpdisable ? client.println("disabled") :   client.println("enabled");
  client.println("<br>");

  client.print("disciplining is ");
  client.println (getDisciplineName(activestate.discipline) );
  client.println("<br>");

  if (activestate.discipline == GNSS || activestate.discipline == Ext10 ) {
    if (cleanupPLL.checkADF4001locked())
      client.println(" Reference is Locked<br>" );
    else
      client.println("Reference is  Unlocked<br>" );
  }

  if (!COMPILED_FOR_REFERENCE) {  //  send ADF4351 lock status


    if (Synth1.ADF4351locked())
      client.println(" <h3 style='color:green;'>LO1 PLL is Locked </h3> " );
    else
      client.println(" <h3 style='color:red;'>LO1 PLL is Unlocked </h3> " );

    if (Synth2.ADF4351locked())
      client.println(" <h3 style='color:green;'>LO2&LO3 PLL is Locked </h3> " );
    else
      client.println(" <h3 style='color:red;'>LO2&LO3 PLL is Unlocked </h3> " );
  }

  client.print("XO temperature = ");
  client.println( readPCBTemp(), 1  );
  client.println("C<br><br>");

  client.print("activestate DAC setting (");
  client.print( activestate.dacsetting );
  client.println(" bits) (Vset/p21) ==>  ");
  client.print ( (float) activestate.dacsetting * (AREF / 4096.0), 3 ); //  DAC uses AREF 4V reference
  client.println(" VDC<br>");

  client.print("Measured (Vset on p21) (");
  uint16_t db = averageBitRead(VSET_PIN);
  client.print ( db   );
  client.print(" bits) ==>  ");
  client.print (  (  (float) db / 4096.0) * calcArefV , 3 ); //  ADC uses reference V on at IoT pin
  client.println(" VDC<br>");

  client.print("Measured Tuning voltage (TuneIn/p20) (");
  uint16_t tb = averageBitRead(VTUNE_PIN);
  client.print ( tb   );
  client.print(" bits) ==>  ");
  client.print (( (float) tb / 4096.0) * (calcArefV ), 3 );
  client.println(" VDC<br>");

  client.println("<br>");
  long rssi = WiFi.RSSI();

  client.print("\nWiFi is reporting ");
  client.print(  rssi  );
  client.print(" dBm from SSID: ");
  client.println(WiFi.SSID());
  client.println("<br><br>");

  if (!COMPILED_FOR_REFERENCE)  { // rxconverter state
    client.print("RX Converter  = ");
    if (activestate.rxconverter)  client.println("Enabled<br>");
    else client.println("Bypassed<br>");
    client.print("RX Preamp = ");
    if (activestate.preamp)  client.println("Enabled<br>");
    else client.println("Bypassed<br>");
  }
  if (TRANSVERTER)  {             // txconverter state
    client.print("TX Converter = ");
    (activestate.txconverter)  ? client.println("Enabled<br>") : client.println("Disabled<br>");

    client.print("Transceive = ");
    (activestate.transceive) ?  client.println("Enabled<br><br>") : client.println("Disabled<br><br>");
  }
  // *******************************************Home Page URL**************************************************
  if (!COMPILED_FOR_REFERENCE) {  //  send ADF4351 and LO description
    client.print("    LO1 VCO Frequency = ");
    client.print(String(Synth1.ADF4351cfreq / 1e6, 6));
    client.println(" MHz<br>");

    client.print("    Synth1A+ Pwrlevel = ");
    client.println(String(Synth1.ADF4351MainPwrlevel));
    client.println("<br>");

    ( Synth1.auxIsPowered) ? client.println("    Synth1B+ is ON") : client.println("    Synth1B+ is OFF");
    client.println("<br>");

    client.print("    Synth1B+ Pwrlevel = ");
    client.println(String(Synth1.SynthBPwrlevel));
    client.println("<br>");

    client.print("    LO1 reference doubler = ");
    client.println(String(Synth1.ADF4351Refdoubler));
    client.println("<br>");
    client.print("    LO1 Reference divideBy2 = ");
    client.println(String(Synth1.ADF4351Refdivider));
    client.println("<br>");

    client.print("    LO1 ClkDiv (timeout counter)= ");
    client.println(String(Synth1.ADF4351TimeoutCounter));
    client.println("<br>");

    client.print("    LO1 BandSelClock (internal VCO bands) = ");
    client.println(String(Synth1.ADF4351BandSelClock));
    client.println("<br>");

    client.print("    LO1 10 bit R Divbider = ");
    client.println(String(Synth1.ADF4351RCounter));
    client.println("<br>");

    client.print("    LO1 ChanStep = ");
    client.println(String(Synth1.ADF4351ChanStep / 1e6, 6));
    client.println(" MHz<br>");

    client.print("    LO1 Output divider = ");
    client.println(String(Synth1.ADF4351outdiv));
    client.println("<br>");

    client.print("Synth Phase comparison Frequency,         fPFD = REFin * [ (1 + D)/(R * (1 + T)) ] = ");
    client.println(String(Synth1.ADF4351PFDFreq / 1e6, 6));
    client.println(" MHz<br>");
    client.println("where:<br>");
    client.print("REFin is the reference frequency input = ");
    client.println(String(UWVREFERENCE / 1e6, 0));
    client.println(" MHz");
    client.println("<br>");

    client.print("D is the RF REF IN doubler bit (0 or 1) = ");
    client.println(String(Synth1.ADF4351Refdoubler));
    client.println("<br>");

    client.print("R is the RF reference division factor (1 to 1023) = ");
    client.println(String(Synth1.ADF4351RCounter));
    client.println("<br>");

    client.print("T is the reference divide-by-2 bit (0 or 1) = ");
    client.println(String(Synth1.ADF4351Refdivider));
    client.println("<br>");
    //
    client.print("RFout is the LO1 VCO Frequency, LO1 = fpfd * (INT + (FRAC/MOD)) = ");
    client.println(String(Synth1.ADF4351cfreq / 1e6, 6));
    client.print(" where: ");

    client.print("INT  = ");
    client.println(String(Synth1.ADF4351N_Int));
    client.println("<br>");

    client.print("FRAC is the numerator of the fractional division (0 to MOD-1) = ");
    client.println(String(Synth1.ADF4351Frac));
    client.println("<br>\n");

    client.print("MOD is the preset fractional modulus (2 to 4095) = ");
    client.println(String(Synth1.ADF4351Mod));

    client.print("<br>so, ");
    client.print("Frac-N  = ");
    client.println(String(Synth1.ADF4351cfreq / Synth1.ADF4351PFDFreq, 4));
    client.print("<br>");

    if (Synth1.ADF4351Frac == 0) {
      client.println("  so the synthesizer is in INTEGER mode.<br>\n");
    }
    float Synth1core = Synth1.ADF4351cfreq  / 1e6;
    float Synth2core = Synth2.ADF4351cfreq * Synth2.ADF4351outdiv / 1e6;
    float Synth2div = Synth2.ADF4351cfreq / 1e6;
    float IF3 = 20;
    Ftune = (Synth1core - Synth2core + Synth2div + IF3 );           //  maintained in units of MHz system wide
    float IF1 = Synth1core - Ftune;                                 //  in Hz to set IF1
    float IF2 = Synth2core - IF1;
    //
    client.print("A <strong>");
    client.print(Ftune);
    client.print(" MHz </strong>");
    client.print("signal at the converter input with ");
    client.print("Synth1A+ (VCO) = ");
    client.print(String(Synth1core, 0) );
    client.print(" MHz  ===> an IF1 = ");
    client.print(String(IF1, 0) );
    client.println(" MHz<br>");

    client.print("which with Synth2B (VCO) = ");
    client.print(String(Synth2core, 0) );
    client.print(" MHz ===> an IF2 = ");
    client.print(String(IF2, 0) );
    client.println(" MHz<br>");

    client.print("and with a LO3 ( Synth2A = Synth2B/16 ) = ");
    client.print(String(Synth2div, 0) );
    client.print(" MHz  ===> an output at IF3 = ");
    client.print("<strong>");
    client.print(String(IF3, 0) );
    client.println(" MHz");
    client.print("</strong><br>");


    // **************************************

  } // end of ADF4351 and LO description
 
  client.println("\n=======================Utility===========================<br>");
  //  sendSelectUserClock();

  sendSelectDiscipline();

  selectCPI();

  sendSelectpfdScaling();

  sendPllMUXSelect();

  sendDacXOset();

  if (COMPILED_FOR_REFERENCE) { //  Clock1 adjustment only available on Reference Board
    selectClock1();
  }

  SendLockStatus();

  sendRefresh();  client.print("<br>");
  
  if (TRANSVERTER)  {
  sendForceTx();
  }

  sendTCTableClear();
  
  sendSelectSleep();

  sendResetGNSSmodule();

  sendcurlInfo();
  //
  //
  client.print(" <a href=http://" );
  client.print(WiFi.localIP());
  client.print(":");
  client.print(port);
  client.print("/?Status=");
  client.print(0);
  client.println("> <h3 style='color:black;font-size:16px;'> Back to Home Page</h3>  </a> <br> ");

  //
  // Satellite Info
  if (activestate.discipline == GNSS)  {
    sendSatBars(ubxDataStruct);   //
  }
  //
  //
  client.println("\n</body> ");
  client.println("</html>");
  // The HTTP response ends with another blank line:
  client.print("\n");
} //  end SendStatusPage
 
void webPrintClkStats()  {  //
  si5351c.update_status();

  client.print("SYS_INIT: "); client.print(si5351c.dev_status.SYS_INIT);
  //  client.print("\tLOL_A: "); client.print(si5351c.dev_status.LOL_A);
  //  client.print("\tLOL_B: "); client.print(si5351c.dev_status.LOL_B);
  client.print("\tLOS: "); client.print(si5351c.dev_status.LOS); client.print("  REVID: "); client.println(si5351c.dev_status.REVID);
  client.println("<br>");

  client.print("PLL_A = ");  client.println(si5351c.plla_freq / 1e8, 3); //client.println("<br>");
  client.print("&nbsp&nbsp&nbsp&nbsp&nbsp&nbspPLL_B = ");  client.println(si5351c.pllb_freq / 1e8, 3); client.println("<br>");  client.println("<br>");

  float divisor;
  for (uint8_t i = 0; i < MAX_CLKS; i++)
  {
    if ((si5351c.clk_freq[i]) == 0) {
      client.print("CLK"); client.print(i, 1); client.print(" off ");
    }
    else {
      client.print("CLK"); client.print(i, 1); client.print(" = "); client.print(si5351c.clk_freq[i] / 1e8, DEC); client.println("\t");
      client.print("\tPLL_");
      if (si5351c.pll_assignment[i] == 0)  {
        client.print("A/");
        divisor = (float)si5351c.plla_freq / si5351c.clk_freq[i];
      }
      else {
        client.print("B/");
        divisor = (float)si5351c.pllb_freq / si5351c.clk_freq[i];
      }
      client.println(divisor, 5);
    }
    client.print("\t ");
    client.print(pwrStr[activestate.pwr[i]]); //  elements of pwr[] are 0:3
    client.print (" ");
    si5351c.clk_precision[i]  ?    client.print( si5351c.clk_precision[i], 1 )  :  client.print ("");
    si5351c.clk_precision[i]  ?    client.print("x10<sup>-15</sup>")   :  client.print ("");

    client.println("<br>");
  }
}
 
void executeKeyValuePair(String key, String value) {    //  act on key if possible, sending a return page is a special case
  //  'value' is a String and may be messy since request may be something like "presetClock = 66.66+MHz%28KiWi%29 HTTP/1.1"
  Serial.print("key:value " ); Serial.print(key); Serial.print(":"); Serial.println(value);
  if (key == "requestedBand") { //  set bottom of each band to 20 MHz(center)
    requestedBand = value.toInt();
    if (value == "2200") Ftune = 0 ;
    if (value == "630") Ftune = 0  ;
    if (value == "160") Ftune = 1  ;
    if (value == "80") Ftune = 3  ;
    if (value == "60") Ftune = 5  ;
    if (value == "40") Ftune = 7  ;
    if (value == "30") Ftune = 10  ;
    if (value == "20") Ftune = 14  ;
    if (value == "17") Ftune = 18  ;
    if (value == "15") Ftune = 21  ;
    if (value == "12") Ftune = 24  ;
    if (value == "10") Ftune = 28  ;
    if (value == "6") Ftune = 50  ;
    if (value == "4") Ftune = 70  ;
    if (value == "2") Ftune = 140  ;
    if (value == "1") Ftune = 220  ;
    if (value == "70") Ftune = 440  ;
    if (value == "33") Ftune = 910  ;
    if (value == "23") Ftune = 1290  ;

    activestate.lo1Freq = (Ftune * freq1M) + 2185000000UL;
    SetSynth1(activestate.lo1Freq);
  }
  if (key == "presetClock") {
    if (value == "10")  {              // 800/(80 +0/25) = 10 MHz
      setClock2(freq10M);
    }
    if (value == "20")    {             // 800/(40 +0/25) = 20 MHz
      setClock2(freq20M);
    }
    if (value == "25")    {             // 800/(40 +0/25) = 20 MHz
      setClock2(freq25M);
    }
    if (value == "27")    {             // 800/(40 +0/25) = 20 MHz
      setClock2(freq27M);
    }
    if (value == "50")   {
      setClock2(freq50M);
    }
    if (value == "80")   {
      setClock2(freq80M);
    }
    if (value == "100")   {
      setClock2(freq100M);
    }
    if (value == "125")   {
      setClock2(freq125M);
    }
    if (value == "Kiwi")   {          //  66.672 MHz for Kiwi
      setClock2(freq66M);
    }
    if (value == "RTL")   {
      setClock2(freq80M);
    }    if (value == "RTL")   {
      setClock2(freq80M);
    }
    if (value == "TRXduo")   {
      setClock6(freq125M);
    }
    if (value == "IC7300")   {        //  41.344 MHz for IC7300
      setClock2(freq41M);
    }
    if (value == "IC706")   {         //  30 MHz for IC706
      setClock2(freq30M);
    }
    if (value == "TS200")   {
      setClock2(freq15p6M);
    }
    if (value == "FT8x7")   {         //  22.625 MHz for FT8x7 series
      setClock2(freq22M);
    }
  }
  if (key == "clock1") {
    if (value == "10")  {              // 800/(80 +0/25) = 10 MHz
      setClock1(freq10M);
    }
    if (value == "20")    {             // 800/(40 +0/25) = 20 MHz
      setClock1(freq20M);
    }
    if (value == "25")    {             // 800/(40 +0/25) = 20 MHz
      setClock1(freq25M);
    }
    if (value == "27")    {             // 800/(40 +0/25) = 20 MHz
      setClock1(freq27M);
    }
    if (value == "100")   {
      setClock1(freq100M);
    }
    if (value == "125")   {
      setClock1(freq125M);
    }
  }
  if (key == "pwr1") {                  //   note: BOGUS currents, 2mA in 50 ohms is -7 dBm
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[1] = (uint8_t) drive;               //  is maintained as uint8_t, using only b1,b0
    si5351c.drive_strength(SI5351_CLK1, drive);         //  **warning, this does a read that may be faulty on IoT33**
  }
  if (key == "pwr2") {                    //
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[2] = (uint8_t) drive;                //  is maintained as uint8_t, using only b1,b0
    si5351c.drive_strength(SI5351_CLK2, drive); //  is maintained as uint8_t, using only b1,b0
  }
  if (key == "pwr3") {                    //
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[3] = (uint8_t) drive;                //  is maintained as uint8_t, using only b1,b0
    si5351c.drive_strength(SI5351_CLK3, drive);   //  is maintained as uint8_t, using only b1,b0
  }
  if (key == "pwr4") {                    //
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[4] = (uint8_t) drive;                //  is maintained as uint8_t, using only b1,b0
    si5351c.drive_strength(SI5351_CLK4, drive); //  is maintained as uint8_t, using only b1,b0
  }
  if (key == "pwr5") {                    //
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[5] = (uint8_t) drive;              //  is maintained as a uint8_t[]
    si5351c.drive_strength(SI5351_CLK5, drive); //  is maintained as uint8_t, using only b1,b0
  }
  if (key == "pwr6") {                    //
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[6] = (uint8_t) drive;              //  is maintained as a uint8_t[]
    si5351c.drive_strength(SI5351_CLK6, drive); //  is maintained as uint8_t, using only b1,b0
  }
  if (key == "pwr7") {                    //
    si5351_drive drive;                 //  but the method uses the enum si5351_drive drive
    if (value == "4") {
      drive = SI5351_DRIVE_2MA;
    }
    if (value == "9") {
      drive = SI5351_DRIVE_4MA;
    }
    if (value == "11") {
      drive = SI5351_DRIVE_6MA;
    }
    if (value == "13") {
      drive = SI5351_DRIVE_8MA;
    }
    activestate.pwr[7] = (uint8_t) drive;              //  is maintained as a uint8_t[]
    si5351c.drive_strength(SI5351_CLK7, drive); //  is maintained as uint8_t, using only b1,b0
  }
  if (key == "lo1Freq") {                 //  set LO1 directly
    activestate.lo1Freq = strtoul(value.c_str(), NULL, 10);   //    Entry was MHz
    Ftune = activestate.lo1Freq - 2185;                       //  update Ftune (also  MHz)
    Serial.print("\nFtune is ");
    Serial.println((float)(activestate.lo1Freq - 2185.0), 6);
    Serial.print("\nLO1 Freq is ");
    Serial.println((float)activestate.lo1Freq, 1);
    activestate.lo1Freq  *=  freq1M;                          // but synth setting is in Hz
    SetSynth1(activestate.lo1Freq);
  }
  if (key == "Ftune") {                   //  set LO1 in terms of frequency to be converted to 20 MHz
    Ftune = strtoul(value.c_str(), NULL, 10);   //    turns the value associated with 'Ftune' key into a uint32_t for the variable Ftune

    activestate.lo1Freq =  (Ftune * freq1M) + 2185000000UL;
    SetSynth1(activestate.lo1Freq);
  }
  if (key == "Quicktune") {               //  set LO1 in terms of frequency to be converted to 20 MHz
    Ftune = strtoul(value.c_str(), NULL, 10);   //    turns the value associated with 'Ftune' key into a uint32_t for the variable Ftune

    activestate.lo1Freq =  (Ftune * freq1M) + 2185000000UL;
    SetSynth1(activestate.lo1Freq);
    htmlPageToSend = 4;                         //  Send as little data as possible to speed up tuning
  }
  if (key == "setCLK1Freq") {        //  Only selected values parsed
    //
    //    if (value == "10")   {
    //      setClock1((uint32_t) freq10M);
    //    }
    //    if (value == "20")   {
    //      setClock1((uint32_t)freq20M);
    //    }
    //    if (value == "25")   {
    //      setClock1((uint32_t)freq25M);
    //    }
    //    if (value == "27")   {
    //      setClock1((uint32_t)freq27M);
    //    }
    //    if (value == "100")   {
    //      setClock1(freq100M);
    //    }
    uint32_t fset = strtoul(value.c_str(), NULL, 10);
    setClock1(fset);
  }
  if (key == "setCLK2Freq") {
    uint32_t setCLK2Freq = strtoul(value.c_str(), NULL, 10);
    setClock2(setCLK2Freq);
  }
  if (key == "setCLK3Freq") {
    uint32_t setCLK3Freq = strtoul(value.c_str(), NULL, 10);
    setClock3(setCLK3Freq);
  }
  if (key == "setCLK4Freq") {
    uint32_t setCLK4Freq = strtoul(value.c_str(), NULL, 10);
    setClock4(setCLK4Freq);
  }
  if (key == "setCLK5Freq") {
    uint32_t setCLK5Freq = strtoul(value.c_str(), NULL, 10);
    setClock5(setCLK5Freq);
  }
  if (key == "setCLK6Freq") {
    uint32_t setCLK6Freq = strtoul(value.c_str(), NULL, 10);
    setClock6(setCLK6Freq);
  }
  if (key == "setCLK7Freq") {
    uint32_t setCLK7Freq = strtoul(value.c_str(), NULL, 10);
    setClock7(setCLK7Freq);
  }
  if (key == "Status") {
    htmlPageToSend = value.toInt() ;
  }
  if (key == "rx_en") {         //  flip bypass to enable converter path
    if (value == "1") activestate.rxconverter = true;
    if (value == "0") activestate.rxconverter = false;
    setRxConverter(activestate.rxconverter);
  }
  if (key == "tx_en") {         //  enables tx, actually keyed with PTT
    if (value == "1")   activestate.txconverter = true;
    if (value == "0")  activestate.txconverter = false;
    setTxConverter(activestate.txconverter);
    obeyPTT();      //    update for ForceTX case as well
  };
  if (key == "ForcePTT") {         //  enables tx, ignoring PTT
    if (value == "1")   forceTx = true;
    if (value == "0")  forceTx = false;
    obeyPTT();
  };
  if (key == "setPreamp") {     //  flip setPreamp bits accordingly
    if (value == "1") {
      setPreamp(true);
    };
    if (value == "0") {
      setPreamp(false);
    };
  }
  if (key == "AllClocks") {     //   Synths power
    if (value == "1") {
      Synth1.synthPowerUp();
      Synth2.synthPowerUp();
    };
    if (value == "0") {
      Synth1.synthPowerDown();
      Synth2.synthPowerDown();
    };
  }
  if (key == "SetSynth1") {     //  Synth1 main Output Enable
    if (value == "1") {
      Synth1.ADF4351setf(activestate.lo1Freq);
      Synth1.mainOutEnable(true);
    };
    if (value == "0") {
      Synth1.mainOutEnable(false);
    };
  }
  if (key == "SetSynth1B") {   //  txLO1 Enable bit
    if (value == "1") {
      Synth1.ADF4351setf(activestate.lo1Freq);
      Synth1.auxOutEnable(true);
    };
    if (value == "0") {
      Synth1.auxOutEnable(false);
    };
  }
  if (key == "SetSynth2B") {     //  flip LO2 Output Enable
    if (value == "1") {
      Synth2.ADF4351setf(LO3FREQ);
      Synth2.auxOutEnable(true);
    };
    if (value == "0") {
      Synth2.auxOutEnable(false);
    };
  }
  if (key == "SetLO3") {        //  Move LO3 frequency up to Synth2 (can't turn it off without also turning off Synth2)
    if (value == "1") {
      //  Synth2.R[4].setbf(20, 3, 16) ;     // rf output divide down by 16
      //  Synth2.ADF4351writeAllReg();
      Synth2.mainOutEnable(true);
    };
    if (value == "0") {
      //    Synth2.R[4].setbf(20, 3, 1) ; // rf divider select fundamental instead of divide down by 16
      //    Synth2.ADF4351writeAllReg();
      Synth2.mainOutEnable(false);        //  doesn't this shut off L02 as well as LO3?  **TODO**
    };
  }
  if (key == "discipline") {    //  change the variable and reconfigure reference
    discipline = disciplineType( value.toInt() );
    setHWDiscipline( discipline);
  }
  if (key == "autoPromote") {   //  change the variable and reconfigure reference
    (value.toInt() == 1) ? activestate.autoPromote = true : activestate.autoPromote = false;
  }
  if (key == "GNSSreset") {     //  Factory reset of GNSS Module next restart
    activestate.gnssReset = true;  //  Factory reset of GNSS module on next startup
    writeStateToEEPROM(activestate); // save it for next start**NOFLASH**
  }
  if (key == "Sleep") {         //  Sleep for 16 seconds
    Watchdog.sleep();           // board will be idle for 16 seconds
  }
  if (key == "refVCXOdac") {         // Adjust un-TCed XO dac
    activestate.refVCXOdac =  value.toInt() ;
    Serial.print("refVCXOdac changed to "); Serial.println(activestate.refVCXOdac);
    setHWDiscipline(  activestate.discipline);  //  update from new setting
    activeStateHasChangedfromWeb = true;  //  Flag the change;    //    Flag the change
  }
  if (key == "refVCXOT") {        // Adjust un-TCed XO dac
    activestate.refVCXOT =   value.toInt() ;
    setHWDiscipline(  activestate.discipline);  //  update from new setting
    activeStateHasChangedfromWeb = true;  //  Flag the change;    //    Flag the change
  }
  if (key == "TCTableClear") {
    readPCBTemp();  //  updates PCBTemperature
    activestate.refVCXOT = PCBTemperature;             // TC Table can build on this temperature/dacvalue point
    Serial.print(" Cleared TC table, refVCXOT = "); Serial.print(activestate.refVCXOT, 1); Serial.println(" C");
    tcTableSize = 0;                                   //  startup condition
    setHWDiscipline(  activestate.discipline);         //  update setting so main loop will find it and rerun from cold start
  }
  if (key == "pllMux") {        //
    if (value == "3ST") {
      cleanupPLL.pllMux = 0 ;
    }
    else if (value == "DLD")  {
      cleanupPLL.pllMux = 1 ;
    }
    else if (value == "NDIV") {
      cleanupPLL.pllMux = 2 ;
    }
    else if (value == "VDD")  {
      cleanupPLL.pllMux = 3 ;
    }
    else if (value == "RDIV") {
      cleanupPLL.pllMux = 4 ;
    }
    else if (value == "OLD") {
      cleanupPLL.pllMux = 5 ;
    }
    else if (value == "SER") {
      cleanupPLL.pllMux = 6 ;
    }
    else if (value == "GND") {
      cleanupPLL.pllMux = 7 ;
    }
    cleanupPLL.ADF4001setHWRegisters();
    activestate.pllMux = cleanupPLL.pllMux ;
  }
  if (key == "pfdScaling") {                                          //  change pfdScaling for the current discipline
    int newscale = value.toInt();                                     // new scaling value gets implemented here

    if (activestate.discipline == GNSS) {
      activestate.GNSSpfdScaling = newscale;
      cleanupPLL.RCounter  = activestate.GNSSpfdScaling;              //  internal ADF4001 R & N dividers
      cleanupPLL.ADF4001_R[0].setbf(2, 14, cleanupPLL.RCounter) ;     // 14 bit (R)eference Counter, divides either GNSS timepulse or Ext10
      cleanupPLL.NCounter  = cleanupPLL.RCounter;                     //  equal ref and rf pin frequencies so RCounter = NCounter
      cleanupPLL.ADF4001_R[1].setbf(8, 13, cleanupPLL.NCounter) ;     // 13 bit iNput Counter, divides the input from Clock0
      cleanupPLL.ADF4001counterResetMethod();
      Serial.print("GNSS Phase Detector Freq scaling is 1/");
      Serial.println (activestate.GNSSpfdScaling);
    }
    else if (activestate.discipline == Ext10) {
      activestate.EXTpfdScaling = newscale;
      cleanupPLL.RCounter  = activestate.EXTpfdScaling;               //  internal ADF4001 R & N dividers
      cleanupPLL.ADF4001_R[0].setbf(2, 14, cleanupPLL.RCounter) ;     // 14 bit (R)eference Counter, divides either GNSS timepulse or Ext10
      cleanupPLL.NCounter  = cleanupPLL.RCounter;                     //  equal ref and rf pin frequencies so RCounter = NCounter
      cleanupPLL.ADF4001_R[1].setbf(8, 13, cleanupPLL.NCounter) ;     // 13 bit iNput Counter, divides the input from Clock0
      cleanupPLL.ADF4001counterResetMethod();
      Serial.print("Ext Phase Detector Freq scaling is 1/");
      Serial.println (activestate.EXTpfdScaling);
    }
    activeStateHasChangedfromWeb = true;                              //
  }
  if (key == "cpdisable") {     //  change the variable and
    if (value.toInt() == 1)  {
      cleanupPLL.cpdisable = true;
    }
    if (value.toInt() == 0)  {
      cleanupPLL.cpdisable = false;
    }
    activestate.cpdisable =  cleanupPLL.cpdisable;
    activeStateHasChangedfromWeb = true;
    cleanupPLL.ADF4001setHWRegisters();
  }
  if (key == "cpcurrent") {     //  change the variable and reconfigure CP Current
    cleanupPLL.cpcurrent = (uint8_t)  value.toInt();
    activestate.cpcurrent = cleanupPLL.cpcurrent;
    cleanupPLL.ADF4001setHWRegisters();
    activeStateHasChangedfromWeb = true;;    //
  }
  if (key == "GNSSsys") {       //
    if (value == "GPS") {
      gnssState.GPS = !gnssState.GPS;
      myGNSS.enableGNSS(gnssState.GPS,  SFE_UBLOX_GNSS_ID_GPS, 250);
    }
    if (value == "GALILEO") {
      gnssState.GALILEO = !gnssState.GALILEO;
      myGNSS.enableGNSS(gnssState.GALILEO,  SFE_UBLOX_GNSS_ID_GALILEO, 250);
    }
    if (value == "QZSS") {
      gnssState.QZSS = !gnssState.QZSS;
      myGNSS.enableGNSS(gnssState.QZSS,  SFE_UBLOX_GNSS_ID_QZSS, 250);
    }
    if (value == "GLONASS") {
      gnssState.GLONASS = !gnssState.GLONASS;
      myGNSS.enableGNSS(gnssState.GLONASS,  SFE_UBLOX_GNSS_ID_GLONASS, 250);
    }
    if (value == "BEIDOU") {
      gnssState.BEIDOU = !gnssState.BEIDOU;
      myGNSS.enableGNSS(gnssState.BEIDOU,  SFE_UBLOX_GNSS_ID_BEIDOU, 250);
    }
  }
  key = "";                     // don't want to execute twice
} //  end executeKeyValuePair
 
void processGet (const char * data) {           //    extract key:value pair from a GET line
  // Example GET line: GET /?presetClock=66.660+MHz HTTP/1.1
  const int MAX_PARAM = 100;// the maximum length of parameters we accept

  // find where the parameters start
  const char * paramsPos = strchr (data, '?');
  if (paramsPos == NULL)
    return;  // no parameters
  // find the trailing space before the 'HTTP'
  const char * spacePos = strchr (paramsPos, ' ');
  if (spacePos == NULL)
    return;  // no space found
  // work out how long the parameters are
  int paramLength = spacePos - paramsPos - 1;
  // see if too long
  if (paramLength >= MAX_PARAM)
    return;  // too long for us
  // copy parameters into a buffer
  char param [MAX_PARAM];
  memcpy (param, paramsPos + 1, paramLength);  // skip the "?"
  param [paramLength] = 0;  // null terminator
  //Serial.print("param is "); // DEBUG
  //Serial.println(param); // DEBUG
  // do things depending on argument (GET parameters)

  String key = "NULL", value = "NULL";
  key = strtok(param, " = "); // first call to strtok returns the key ('name' from the FORM GET)
  // Serial.print("key is "); // DEBUG

  value = strtok(NULL, " ");  // get the value, , (strtok is reentrant so hand it a NULL to continue)

  //  may have trailing '+' before a space for additional text, strip it off.
  int plusPosition = value.indexOf('+');
  if (plusPosition == 0 )  value.setCharAt(plusPosition, 0);
  //
  //  rip = client.remoteIP(); // DEBUG
  //  Serial.println(""); // DEBUG
  //  Serial.print(rip); // DEBUG
  //  //
  //  Serial.print("\nkey:value ==> "); // DEBUG
  //  Serial.print(key); // DEBUG
  //  Serial.print(":"); // DEBUG
  //  Serial.print(value); // DEBUG
  //  Serial.print("\n"); // DEBUG
  //
  executeKeyValuePair( key,  value);  //   key comes from Form 'name', value comes from Form 'value'

  value = "null";
  key = "null";
}  // end of processGet
 
boolean WebServersetup() {                     //returns 'false' if no wiFiConnection to AP
  boolean wiFiConnection = false;

  if (WiFi.status() == WL_NO_MODULE) {  // check for the WiFi module:
    Serial.println("Communication with WiFi module failed!");
    wiFiModulePresent = false;
  }
  else  {
    wiFiModulePresent = true;
    digitalWrite(LOW_WiFi1, HIGH);
    digitalWrite(Synth2_PIN_LOCK, HIGH);
    
    String fv = WiFi.firmwareVersion();
    if (fv < WIFI_FIRMWARE_LATEST_VERSION) {
      Serial.print("WIFI FW is v"); Serial.print(fv);
      Serial.print(" latest is v"); Serial.print(WIFI_FIRMWARE_LATEST_VERSION);
      Serial.println(" upgrade via IDE if desired");
    }

    Serial.print("Attempting to connect to WiFi AP named: ");
    Serial.print (activestate.ssid);
//    
//    status = WiFi.begin(activestate.ssid, activestate.pass);  //  send  credentials 1st time
//    delay(1000);  // Not certain about this timing.  How long does it take a busy WiFi network to get an answer if all is OK?
//    status = WiFi.status(); 
//    
    const uint16_t trydelay = 1000;
    uint8_t tries=1;  //  Have to keep trydelay*tries under watchdog timer timeout, if it is enabled (avoid this)       
    while (status != WL_CONNECTED) {                            //  waiting  for connect to Wifi network:   
      status = WiFi.begin(activestate.ssid, activestate.pass);  //  sending credentials over and over?    
      delay(trydelay);  // Not certain about this timing.  How long does it take a busy WiFi network to get an answer if all is OK?
      status = WiFi.status();
      
       if (status == WL_CONNECTED)  {
          Serial.print("\n***Connected to WiFi after ");
          Serial.print( tries );
          Serial.println(" retries***");
        break;
      }
      if (tries++ >= 10) {   //  limit delay*tries << watchdog timer in case this is an attempt to restart a running WiFiNINA
        Serial.println("Timed out trying to connect to WiFi ");
        break;
      };
          Serial.print(".");
    }   // end of AP connection attempt
 
    if ((status == WL_CONNECTED))  {         // if connected now,  start the web server and print out the status
      wiFiConnection = true;
      digitalWrite(LOW_WiFi1, LOW);         //  indicate have AP on WiFi LED
      server.begin();
      printWifiStatus();
    }
    else  { //  No connection to Network
      Serial.println("No connection to Network");
      wiFiConnection = false;
      digitalWrite(Synth1_PIN_LOCK, HIGH);
      digitalWrite(Synth2_PIN_LOCK, HIGH);
    }
  }   // end of WiFi module present
  return (wiFiConnection);
} //  end  WebServersetup
 
void  WebServerloop() {                           // listen for incoming client and process anything that comes in
  client = server.available();                    // non-null if some Client has data available for reading
  digitalWrite(LOW_WiFi2, HIGH);
  if (client) {
    digitalWrite(LOW_WiFi2, LOW);
    String currentLine = "";                      // make a new String to hold incoming data from the client
    boolean currentLineIsBlank = true;
    while (client.connected()) {                  // loop while the client's connected, (hasn't sent terminating line)
      if (client.available()) {                   // if there's a byte to read from the client,
        char c = client.read();                   // read the byte, then
        if (c == '\n' && currentLineIsBlank)  {   // Terminator, send a page in response then  break out to close the connection
          switch (htmlPageToSend )  {
            case 0:
              SendHomePage(client) ;
              break;
            case 1:
              SendStatusPage(client) ;
              break;
            case 2:
              SendStatusTextPage(client) ;
              break;
            default:
              SendBlankPage(client) ;
              break;
          }
          break;
        }
        if (c == '\n' && !currentLineIsBlank) {   // Got a newline but previous is not Blank so process it
          if (  currentLine.startsWith("GET ") && currentLine.endsWith("1.1")   )   processGet (&currentLine [0]);
          currentLineIsBlank = true;              // starting a new line
        }
        else if (c != '\r') {                     // got a character for the current line
          currentLine += c;
          currentLineIsBlank = false;
        }
      }
    } //  end while client.connected
    delay(1);                                     // give the web browser time to receive the data
    client.stop();                                //  close the connection:
    
  Watchdog.reset();     //  This is to avoid a timeout if/when remote user has another request queued up
  }
} // end WebServerloop
